Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 1047)
+++ palm/trunk/SOURCE/modules.f90	(revision 1053)
@@ -20,5 +20,19 @@
 ! Current revisions:
 ! -----------------
-!
+! necessary expansions according to the two new prognostic equations (nr, qr) 
+! of the two-moment cloud physics scheme:
+! +*_init, flux_l_*, diss_l_*, flux_s_*, diss_s_*, *sws, *swst, tend_*, *, *_p
+! +t*_m, *_1, *_2, *_3, *_av, bc_*_b, bc_*_t, ibc_*_b, ibc_*_t, bc_*_t_val, 
+! +*_vertical_gradient, *_surface_initial_change, *_vertical_gradient_level, 
+! +*_vertical_gradient_level_ind, *_surface, constant_waterflux_*,  
+! +cloud_scheme, icloud_scheme, surface_waterflux_*, sums_ws*s_ws_l, wall_*flux
+!
+! constants for the two-moment scheme:
+! +a_vent, a_term, b_vent, b_term, c_evap, c_term, cof, eps_sb, k_cc, k_cr, k_rr, 
+! +k_br, kappa_rr, kin_vis_air, mu_constant_value, nc, pirho_l, dpirho_l, rho_1,
+! +schmidt, schmidt_p_1d3, stp, x0, xmin, xmax, dt_precipitation, w_precipitation
+!
+! steering parameters for the two_moment scheme:
+! +mu_constant, ventilation_effect
 !
 ! Former revisions:
@@ -369,37 +383,43 @@
           c_u_m, c_u_m_l, c_v_m, c_v_m_l, c_w_m, c_w_m_l, ddzu, ddzu_pres,     &
           dd2zu, dzu, ddzw, dzw, hyp, inflow_damping_factor, lad, l_grid,      &
-          ptdf_x, ptdf_y, pt_init, q_init, rdf, rdf_sc, sa_init, ug, u_init,   &
-          u_nzb_p1_for_vfc, vg, v_init, v_nzb_p1_for_vfc, w_subs, zu, zw 
+          nr_init, ptdf_x, ptdf_y, pt_init, q_init, qr_init, rdf, rdf_sc,      &
+          sa_init, ug, u_init, u_nzb_p1_for_vfc, vg, v_init, v_nzb_p1_for_vfc, &
+          w_subs, zu, zw
 
     REAL, DIMENSION(:,:), ALLOCATABLE ::                                       &
-          c_u, c_v, c_w, diss_s_e, diss_s_pt, diss_s_q, diss_s_sa, diss_s_u,   &
-          diss_s_v, diss_s_w, dzu_mg, dzw_mg, flux_s_e, flux_s_pt, flux_s_q,   &
-          flux_s_sa, flux_s_u, flux_s_v, flux_s_w, f1_mg, f2_mg, f3_mg,        &
-          mean_inflow_profiles, pt_slope_ref, qs, qsws, qswst, qswst_remote,   &
-          rif, saswsb, saswst, shf, total_2d_a, total_2d_o, ts, tswst, us,     &
-          usws, uswst, vsws, vswst, z0, z0h
+          c_u, c_v, c_w, diss_s_e, diss_s_nr, diss_s_pt, diss_s_q, diss_s_qr,  &
+          diss_s_sa, diss_s_u, diss_s_v, diss_s_w, dzu_mg, dzw_mg, flux_s_e,   &
+          flux_s_nr, flux_s_pt, flux_s_q, flux_s_qr, flux_s_sa, flux_s_u,      &
+          flux_s_v, flux_s_w, f1_mg, f2_mg, f3_mg, mean_inflow_profiles, nrs,  &
+          nrsws, nrswst, pt_slope_ref, qs, qsws, qswst, qswst_remote, qrs,     &
+          qrsws, qrswst, rif, saswsb, saswst, shf, total_2d_a, total_2d_o, ts, &
+          tswst, us, usws, uswst, vsws, vswst, z0, z0h
+          
 
     REAL, DIMENSION(:,:,:), ALLOCATABLE ::                                     &
           canopy_heat_flux, cdc, d, de_dx, de_dy, de_dz, diss, diss_l_e,       &
-          diss_l_pt, diss_l_q, diss_l_sa, diss_l_u, diss_l_v, diss_l_w,        &
-          flux_l_e, flux_l_pt, flux_l_q, flux_l_sa, flux_l_u, flux_l_v,        &
-          flux_l_w, kh, km, lad_s, lad_u, lad_v, lad_w, lai, l_wall, p_loc,    &
-          sec, sls, tend, u_m_l, u_m_n, u_m_r, u_m_s, v_m_l, v_m_n, v_m_r,     &
-          v_m_s, w_m_l, w_m_n, w_m_r, w_m_s
+          diss_l_nr, diss_l_pt, diss_l_q, diss_l_qr, diss_l_sa, diss_l_u,      &
+          diss_l_v, diss_l_w, flux_l_e, flux_l_nr, flux_l_pt, flux_l_q,        &
+          flux_l_qr, flux_l_sa, flux_l_u, flux_l_v, flux_l_w, kh, km, lad_s,   &
+          lad_u, lad_v, lad_w, lai, l_wall, p_loc, sec, sls, tend, tend_pt,    &
+          tend_nr, tend_q, tend_qr, u_m_l, u_m_n, u_m_r, u_m_s, v_m_l, v_m_n,  &
+          v_m_r, v_m_s, w_m_l, w_m_n, w_m_r, w_m_s
+            
 
 #if defined( __nopointer )
     REAL, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::                             &
-          e, e_p, p, prho, pt, pt_p, q, q_p, ql, ql_c, ql_v, ql_vp, rho, sa,   &
-          sa_p, te_m, tpt_m, tq_m, tsa_m, tu_m, tv_m, tw_m, u, u_p, v, v_p,    &
-          vpt, w, w_p
+          e, e_p, nr, nr_p, p, prho, pt, pt_p, q, q_p, ql, ql_c, ql_v, ql_vp,  &
+          qr, qr_p, rho, sa, sa_p, te_m, tnr_m, tpt_m, tq_m, tqr_m, tsa_m,     &
+          tu_m, tv_m, tw_m, u, u_p, v, v_p, vpt, w, w_p
 #else
     REAL, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::                             &
-          e_1, e_2, e_3, p, prho_1, pt_1, pt_2, pt_3, q_1, q_2, q_3, ql_v,     &
-          ql_vp, ql_1, ql_2, rho_1, sa_1, sa_2, sa_3, u_1, u_2, u_3,           &
-          v_1, v_2, v_3, vpt_1, w_1, w_2, w_3
+          e_1, e_2, e_3, p, prho_1, nr_1, nr_2, nr_3, pt_1, pt_2, pt_3, q_1,   &
+          q_2, q_3, ql_v, ql_vp, ql_1, ql_2, qr_1, qr_2, qr_3, rho_1, sa_1,    &
+          sa_2, sa_3, u_1, u_2, u_3, v_1, v_2, v_3, vpt_1, w_1, w_2, w_3
 
     REAL, DIMENSION(:,:,:), POINTER ::                                         &
-          e, e_p, prho, pt, pt_p, q, q_p, ql, ql_c, rho, sa, sa_p, te_m,       &
-          tpt_m, tq_m, tsa_m, tu_m, tv_m, tw_m, u, u_p, v, v_p, vpt, w, w_p
+          e, e_p, nr, nr_p, prho, pt, pt_p, q, q_p, ql, ql_c, qr, qr_p, rho,   &
+          sa, sa_p, te_m, tnr_m, tpt_m, tq_m, tqr_m, tsa_m, tu_m, tv_m, tw_m,  &
+          u, u_p, v, v_p, vpt, w, w_p
 #endif
 
@@ -429,7 +449,8 @@
 
     REAL, DIMENSION(:,:,:), ALLOCATABLE, TARGET :: &
-          e_av, lpt_av, p_av, pc_av, pr_av, pt_av, q_av, ql_av, ql_c_av,     &
-          ql_v_av, ql_vp_av, qv_av, rho_av, s_av, sa_av, u_av, v_av, vpt_av, &
-          w_av
+          e_av, lpt_av, nr_av, p_av, pc_av, pr_av, prr_av, pt_av, q_av, ql_av, &
+          ql_c_av, ql_v_av, ql_vp_av, qr_av, qv_av, rho_av, s_av, sa_av, u_av, &
+          v_av, vpt_av, w_av
+  
  END MODULE averaging
 
@@ -444,21 +465,64 @@
 !------------------------------------------------------------------------------!
 
-    LOGICAL ::  curvature_solution_effects = .FALSE.
-
-    REAL  ::  bfactor, cp = 1005.0, diff_coeff_l = 0.23E-4,                    &
-              effective_coll_efficiency,                                       &
-              eps_ros = 1.0E-4,             &  ! accuracy of Rosenbrock method
-              l_d_cp, l_d_r, l_d_rv, l_v = 2.5E+06,                            &
-              mass_of_solute = 1.0E-17,              & ! soluted NaCl in kg
-              molecular_weight_of_solute = 0.05844,  & ! mol. mass NaCl (kg/mol)
-              molecular_weight_of_water = 0.01801528,& ! mol. mass H2O (kg/mol)
-              prec_time_const = 0.001, ql_crit = 0.0005, rho_l = 1.0E3,        &
-              r_d = 287.0, r_v = 461.51, thermal_conductivity_l = 2.43E-2,     &
-              vanthoff = 2.0                        ! van't Hoff factor (NaCl)
-
-    REAL, DIMENSION(:), ALLOCATABLE   ::  pt_d_t, t_d_pt
-
-    REAL, DIMENSION(:,:), ALLOCATABLE ::  precipitation_amount, &
-                                          precipitation_rate
+    LOGICAL ::  curvature_solution_effects = .FALSE., &
+                ventilation_effect = .FALSE., &
+                mu_constant = .FALSE.
+
+    REAL ::  a_vent = 0.78,      & ! coef. for ventilation effect 
+             a_term = 9.65,      & ! coef. for terminal velocity (m s-1)
+             b_vent = 0.308,     & ! coef. for ventilation effect
+             b_term = 9.8,       & ! coef. for terminal velocity (m s-1)
+             bfactor,            &
+             c_evap = 0.7,       & ! constant in evaporation
+             c_term = 600.0,     & ! coef. for terminal velocity (m-1)
+             cof(6) = (/ 76.18009172947146,      & ! coefficients in the 
+                         -86.50532032941677,     & ! numerical
+                         24.01409824083091,      & ! calculation of the
+                         -1.231739572450155,     & ! gamma function
+                         0.1208650973866179E-2,  &
+                         -0.5395239384953E-5 /), &
+             cp = 1005.0,        & ! heat capacity of dry air (J kg-1 K-1) 
+             diff_coeff_l = 0.23E-4, & ! diffusivity of water vapor (m2 s-1)
+             effective_coll_efficiency, &
+             eps_ros = 1.0E-4,   & ! accuracy of Rosenbrock method
+             eps_sb = 1.0E-20,   & ! threshold in two-moments scheme
+             k_cc = 4.44E09,     & ! const. rain-rain kernel (m3 kg-2 s-1) 
+             k_cr = 5.25,        & ! const. cloud-rain kernel (m3 kg-1 s-1) 
+             k_rr = 7.12,        & ! const. rain-rain kernel (m3 kg-1 s-1) 
+             k_br = 1000.,       & ! const. in breakup parametrization (m-1)
+             kappa_rr = 60.7,    & ! const. in collision kernel (kg-1/3)
+             kin_vis_air = 1.4086E-5, & ! kin. viscosity of air (m2 s-1)
+             l_v = 2.5E+06,      & ! latent heat of vaporization (J kg-1)
+             l_d_cp, l_d_r, l_d_rv, & ! l_v / cp, l_v / r_d, l_v / r_v
+             mass_of_solute = 1.0E-17, & ! soluted NaCl (kg)
+             molecular_weight_of_solute = 0.05844, & ! mol. m. NaCl (kg mol-1)
+             molecular_weight_of_water = 0.01801528, & ! mol. m. H2O (kg mol-1)
+             mu_constant_value = 0.0, & ! shape param. of gamma distribution
+             nc = 70.0E6,        & ! cloud droplet concentration 
+             prec_time_const = 0.001, & !coef. in Kessler scheme
+             pirho_l, dpirho_l,  & ! pi * rho_l / 6.0; 6.0 / ( pi * rho_l )
+             rho_l = 1.0E3,      & ! density of water (kg m-3)
+             ql_crit = 0.0005,   & ! coef. in Kessler scheme
+             r_d = 287.0,        & ! sp. gas const. dry air (J kg-1 K-1)
+             r_v = 461.51,       & ! sp. gas const. water vapor (J kg-1 K-1)
+             schmidt = 0.71,     & ! Schmidt number
+             schmidt_p_1d3,      & ! schmidt**( 1.0 / 3.0 )
+             stp = 2.5066282746310005, & ! parameter in gamma function
+             thermal_conductivity_l = 2.43E-2, & ! therm. cond. air (J m-1 s-1 K-1)
+             vanthoff = 2.0,     & ! van't Hoff factor for NaCl
+             x0 = 2.6E-10,       & ! separating drop mass (kg)
+             xrmin = 2.6E-10,    & ! minimum rain drop size (kg)
+             xrmax = 5.0E-6,     & ! maximum rain drop site (kg)
+             dt_precipitation = 100.0, & ! timestep precipitation (s)
+             w_precipitation = 9.65      ! maximum terminal velocity (m s-1)
+
+    REAL, DIMENSION(:), ALLOCATABLE     ::  dr, hyrho, lambda_r, mu_r, pt_d_t, &
+                                            sed_nr, sed_q, sed_qr, t_d_pt, xr  
+
+    REAL, DIMENSION(:,:), ALLOCATABLE   ::  precipitation_amount, &
+                                            precipitation_rate
+!
+!-- 3D array of precipitation rate
+    REAL, DIMENSION(:,:,:), ALLOCATABLE ::  prr
 
     SAVE
@@ -529,12 +593,15 @@
                              scalar_advec = 'ws-scheme'
     CHARACTER (LEN=20)   ::  bc_e_b = 'neumann', bc_lr = 'cyclic', &
+                             bc_nr_b = 'dirichlet', bc_nr_t = 'neumann', &
                              bc_ns = 'cyclic', bc_p_b = 'neumann', &
                              bc_p_t = 'dirichlet', bc_pt_b = 'dirichlet', &
                              bc_pt_t = 'initial_gradient', &
                              bc_q_b = 'dirichlet', bc_q_t = 'neumann', &
+                             bc_qr_b = 'dirichlet', bc_qr_t = 'neumann',&
                              bc_s_b = 'dirichlet', bc_s_t = 'neumann', &
                              bc_sa_t = 'neumann', &
                              bc_uv_b = 'dirichlet', bc_uv_t = 'dirichlet', &
                              canopy_mode = 'block', &
+                             cloud_scheme = 'seifert_beheng', &
                              coupling_mode = 'uncoupled', &
                              coupling_mode_remote = 'uncoupled', &
@@ -544,5 +611,5 @@
                              random_generator = 'numerical-recipes', &
                              return_addres, return_username, &
-                             timestep_scheme = 'runge-kutta-3'
+                             timestep_scheme = 'runge-kutta-3'                             
     CHARACTER (LEN=40)   ::  avs_data_file, output_format_netcdf, &
                              topography = 'flat'
@@ -577,6 +644,7 @@
                 dp_level_ind_b = 0, dvrp_filecount = 0, &
                 dz_stretch_level_index, gamma_mg, gathered_size, &
-                grid_level, ibc_e_b, ibc_p_b, ibc_p_t, ibc_pt_b, ibc_pt_t, &
-                ibc_q_b, ibc_q_t, ibc_sa_t, ibc_uv_b, ibc_uv_t, &
+                grid_level, ibc_e_b, ibc_nr_b, ibc_nr_t, ibc_p_b, ibc_p_t, &
+                ibc_pt_b, ibc_pt_t, ibc_q_b, ibc_q_t, ibc_qr_b, ibc_qr_t, &
+                ibc_sa_t, ibc_uv_b, ibc_uv_t, icloud_scheme, &
                 inflow_disturbance_begin = -1, inflow_disturbance_end = -1, &
                 intermediate_timestep_count, intermediate_timestep_count_max, &
@@ -600,6 +668,8 @@
                 mask_size(max_masks,3) = -1, mask_size_l(max_masks,3) = -1, &
                 mask_start_l(max_masks,3) = -1, &
+                nr_vertical_gradient_level_ind(10) = -9999, &
                 pt_vertical_gradient_level_ind(10) = -9999, &
                 q_vertical_gradient_level_ind(10) = -9999, &
+                qr_vertical_gradient_level_ind(10) = -9999, &
                 sa_vertical_gradient_level_ind(10) = -9999, &
                 section(100,3), section_xy(100) = -9999, &
@@ -631,10 +701,12 @@
                 constant_top_momentumflux = .FALSE., &
                 constant_top_salinityflux = .TRUE., &
-                constant_waterflux = .TRUE., create_disturbances = .TRUE., &
+                constant_waterflux = .TRUE., constant_waterflux_nr = .TRUE., &
+                constant_waterflux_qr = .TRUE., create_disturbances = .TRUE., &
                 data_output_2d_on_each_pe = .TRUE., & 
                 dissipation_control = .FALSE., disturbance_created = .FALSE., &
                 do2d_at_begin = .FALSE., do3d_at_begin = .FALSE., &
                 do3d_compress = .FALSE., do_sum = .FALSE., &
-                dp_external = .FALSE., dp_smooth = .FALSE., dt_fixed = .FALSE., &
+                dp_external = .FALSE., dp_smooth = .FALSE., &
+                drizzle = .TRUE., dt_fixed = .FALSE., &
                 dt_3d_reached, dt_3d_reached_l, exchange_mg = .FALSE., &
                 first_call_lpm = .TRUE., &
@@ -668,5 +740,5 @@
              averaging_interval = 0.0, averaging_interval_pr = 9999999.9, &
              averaging_interval_sp = 9999999.9, bc_pt_t_val, bc_q_t_val, &
-             bottom_salinityflux = 0.0, &
+             bc_qr_t_val, bc_nr_t_val, bottom_salinityflux = 0.0, &
              building_height = 50.0, building_length_x = 50.0, &
              building_length_y = 50.0, building_wall_left = 9999999.9, &
@@ -699,4 +771,5 @@
              maximum_cpu_time_allowed = 0.0,  &
              molecular_viscosity = 1.461E-5, &
+             nr_surface = 0.0, nr_surface_initial_change = 0.0, &
              old_dt = 1.0E-10, omega = 7.29212E-5, omega_sor = 1.8, &
              particle_maximum_age = 9999999.9, &
@@ -707,4 +780,5 @@
              pt_surface = 300.0, pt_surface_initial_change = 0.0, &
              q_surface = 0.0, q_surface_initial_change = 0.0, &
+             qr_surface = 0.0, qr_surface_initial_change = 0.0, &
              rayleigh_damping_factor = -1.0, rayleigh_damping_height = -1.0, &
              recycling_width = 9999999.9, residual_limit = 1.0E-4, &
@@ -719,4 +793,5 @@
              surface_heatflux = 9999999.9, surface_pressure = 1013.25, &
              surface_scalarflux = 9999999.9, surface_waterflux = 9999999.9, &
+             surface_waterflux_nr = 0.0, surface_waterflux_qr = 0.0, &
              s_surface = 0.0, s_surface_initial_change = 0.0, &
              termination_time_needed = -1.0, time_coupling = 0.0, &
@@ -740,8 +815,12 @@
              lad_vertical_gradient_level(10) = -9999999.9, &
              mask_scale(3), &
+             nr_vertical_gradient(10) = 0.0, &
+             nr_vertical_gradient_level(10) = -1.0, &
              pt_vertical_gradient(10) = 0.0, &
              pt_vertical_gradient_level(10) = -9999999.9, &
              q_vertical_gradient(10) = 0.0, &
              q_vertical_gradient_level(10) = -1.0, &
+             qr_vertical_gradient(10) = 0.0, &
+             qr_vertical_gradient_level(10) = -1.0, &
              s_vertical_gradient(10) = 0.0, &
              s_vertical_gradient_level(10) = -1.0, &
@@ -759,5 +838,6 @@
              volume_flow(1:2) = 0.0, volume_flow_area(1:2) = 0.0, &
              volume_flow_initial(1:2) = 0.0, wall_heatflux(0:4) = 0.0, &
-             wall_humidityflux(0:4) = 0.0, wall_qflux(0:4) = 0.0, &
+             wall_humidityflux(0:4) = 0.0, wall_nrflux(0:4) = 0.0, & 
+             wall_qflux(0:4) = 0.0, wall_qrflux(0:4) = 0.0, &
              wall_salinityflux(0:4) = 0.0, wall_scalarflux(0:4) = 0.0, &
              subs_vertical_gradient(10) = 0.0, &
@@ -1532,6 +1612,10 @@
                                               sums_us2_ws_l, sums_vs2_ws_l,   &
                                               sums_ws2_ws_l,                  &
+                                              sums_wsnrs_ws_l,                &
                                               sums_wspts_ws_l,                &
-                                              sums_wssas_ws_l,sums_wsqs_ws_l
+                                              sums_wssas_ws_l,                &
+                                              sums_wsqs_ws_l,                 &
+                                              sums_wsqrs_ws_l
+                                              
     REAL, DIMENSION(:,:,:), ALLOCATABLE   ::  hom_sum, rmask, spectrum_x, &
                                               spectrum_y, sums_l, sums_l_l, &
Index: palm/trunk/SOURCE/netcdf.f90
===================================================================
--- palm/trunk/SOURCE/netcdf.f90	(revision 1047)
+++ palm/trunk/SOURCE/netcdf.f90	(revision 1053)
@@ -23,5 +23,5 @@
 ! Current revisions:
 ! ------------------
-!
+! +qr, nr, prr
 !
 ! Former revisions:
@@ -466,6 +466,7 @@
 !
 !--             Most variables are defined on the scalar grid
-                CASE ( 'e', 'lpt', 'p', 'pc', 'pr', 'pt', 'q', 'ql', 'ql_c', &
-                       'ql_v', 'ql_vp', 'qv', 'rho', 's', 'sa', 'vpt' )
+                CASE ( 'e', 'lpt', 'nr', 'p', 'pc', 'pr', 'prr', 'pt', 'q',&
+                       'qc', 'ql', 'ql_c', 'ql_v', 'ql_vp', 'qr', 'qv',    &
+                       'rho', 's', 'sa', 'vpt' )
 
                    grid_x = 'x'
@@ -994,6 +995,7 @@
 !
 !--             Most variables are defined on the scalar grid
-                CASE ( 'e', 'lpt', 'p', 'pc', 'pr', 'pt', 'q', 'ql', 'ql_c', &
-                       'ql_v', 'ql_vp', 'qv', 'rho', 's', 'sa', 'vpt' )
+                CASE ( 'e', 'lpt', 'nr', 'p', 'pc', 'pr', 'prr', 'pt', 'q',   &
+                       'qc', 'ql', 'ql_c', 'ql_v', 'ql_vp', 'qr', 'qv', 'rho',&
+                       's', 'sa', 'vpt' )
 
                    grid_x = 'x'
@@ -1556,7 +1558,8 @@
 !
 !--                   Most variables are defined on the zu grid
-                      CASE ( 'e_xy', 'lpt_xy', 'p_xy', 'pc_xy', 'pr_xy', 'pt_xy',&
-                             'q_xy', 'ql_xy', 'ql_c_xy', 'ql_v_xy', 'ql_vp_xy',  &
-                             'qv_xy', 'rho_xy', 's_xy', 'sa_xy', 'vpt_xy' )
+                      CASE ( 'e_xy', 'lpt_xy', 'nr_xy', 'p_xy', 'pc_xy', 'pr_xy',&
+                             'prr_xy', 'pt_xy', 'q_xy', 'qc_xy', 'ql_xy',        &
+                             'ql_c_xy', 'ql_v_xy', 'ql_vp_xy', 'qr_xy', 'qv_xy', &
+                             'rho_xy', 's_xy', 'sa_xy', 'vpt_xy' )
 
                          grid_x = 'x'
@@ -2142,7 +2145,8 @@
 !
 !--                Most variables are defined on the zu grid
-                   CASE ( 'e_xz', 'lpt_xz', 'p_xz', 'pc_xz', 'pr_xz', 'pt_xz', &
-                          'q_xz', 'ql_xz', 'ql_c_xz', 'ql_v_xz', 'ql_vp_xz',   &
-                          'qv_xz', 'rho_xz', 's_xz', 'sa_xz', 'vpt_xz' )
+                   CASE ( 'e_xz', 'lpt_xz', 'nr_xz', 'p_xz', 'pc_xz', 'pr_xz', &
+                          'prr_xz', 'pt_xz', 'q_xz', 'qc_xz', 'ql_xz',         &
+                          'ql_c_xz', 'ql_v_xz', 'ql_vp_xz', 'qr_xz', 'qv_xz',  &
+                          'rho_xz', 's_xz', 'sa_xz', 'vpt_xz' )
 
                       grid_x = 'x'
@@ -2728,7 +2732,8 @@
 !
 !--                Most variables are defined on the zu grid
-                   CASE ( 'e_yz', 'lpt_yz', 'p_yz', 'pc_yz', 'pr_yz', 'pt_yz',&
-                          'q_yz', 'ql_yz', 'ql_c_yz', 'ql_v_yz', 'ql_vp_yz',  &
-                          'qv_yz', 'rho_yz', 's_yz', 'sa_yz', 'vpt_yz' )
+                   CASE ( 'e_yz', 'lpt_yz', 'nr_yz', 'p_yz', 'pc_yz', 'pr_yz',&
+                          'prr_yz', 'pt_yz', 'q_yz', 'qc_yz', 'ql_yz',        &
+                          'ql_c_yz', 'ql_v_yz', 'ql_vp_yz', 'qr_yz', 'qv_yz', &
+                          'rho_yz', 's_yz', 'sa_yz', 'vpt_yz' )
 
                       grid_x = 'x'
@@ -3915,6 +3920,7 @@
 !
 !--             Most variables are defined on the zu levels
-                CASE ( 'e', 'lpt', 'p', 'pc', 'pr', 'pt', 'q', 'ql', 'ql_c',  &
-                       'ql_v', 'ql_vp', 'qv', 'rho', 's', 'sa', 'u', 'v', 'vpt' )
+                CASE ( 'e', 'lpt', 'nr', 'p', 'pc', 'pr', 'prr', 'pt', 'q',   &
+                       'qc', 'ql', 'ql_c', 'ql_v', 'ql_vp', 'qr', 'qv', 'rho',&
+                       's', 'sa', 'u', 'v', 'vpt' )
 
                    grid_z = 'zu'
Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 1047)
+++ palm/trunk/SOURCE/parin.f90	(revision 1053)
@@ -20,5 +20,9 @@
 ! Current revisions:
 ! -----------------
-!
+! necessary expansions according to the two new prognostic equations (nr, qr) 
+! of the two-moment cloud physics scheme and steering parameters:
+! +*_init, *_surface, *_surface_initial_change, *_vertical_gradient, 
+! +*_vertical_gradient_level, surface_waterflux_*, 
+! +cloud_scheme, drizzle, mu_constant, mu_constant_value, ventilation_effect
 !
 ! Former revisions:
@@ -194,9 +198,10 @@
              canyon_width_x, canyon_width_y, canyon_wall_left, &
              canyon_wall_south, cfl_factor, cloud_droplets, cloud_physics, &
-             collective_wait, conserve_volume_flow, conserve_volume_flow_mode, &
-             coupling_start_time, cthf, curvature_solution_effects, &
-             cycle_mg, damp_level_1d, dissipation_1d, & !dissipation_control, &
+             cloud_scheme, collective_wait, conserve_volume_flow, &
+             conserve_volume_flow_mode, coupling_start_time, cthf, &
+             curvature_solution_effects, cycle_mg, damp_level_1d, &
+             dissipation_1d, & !dissipation_control, &
              dp_external, dp_level_b, dp_smooth, dpdxy, drag_coefficient, &
-             dt, dt_pr_1d, dt_run_control_1d, dx, dy, dz, dz_max, & 
+             drizzle, dt, dt_pr_1d, dt_run_control_1d, dx, dy, dz, dz_max, & 
              dz_stretch_factor, dz_stretch_level, e_init, e_min, end_time_1d, &
              fft_method, galilei_transformation, humidity, &
@@ -208,5 +213,8 @@
              loop_optimization, masking_method, mg_cycles, &
              mg_switch_to_pe0_level, mixing_length_1d, momentum_advec, &
-             netcdf_precision, neutral, ngsrb, nsor, &
+             mu_constant, mu_constant_value, &
+             netcdf_precision, neutral, ngsrb, nr_surface, &
+             nr_surface_initial_change, nr_vertical_gradient, &
+             nr_vertical_gradient_level, nsor, &
              nsor_ini, nx, ny, nz, ocean, omega, omega_sor, &
              passive_scalar, pch_index, phi, plant_canopy, prandtl_layer, &
@@ -215,5 +223,7 @@
              pt_surface_initial_change, pt_vertical_gradient, &
              pt_vertical_gradient_level, q_surface, q_surface_initial_change, &
-             q_vertical_gradient, q_vertical_gradient_level, radiation, &
+             q_vertical_gradient, q_vertical_gradient_level, &
+             qr_surface, qr_surface_initial_change, &
+             qr_vertical_gradient, qr_vertical_gradient_level, radiation, &
              random_generator, random_heatflux, rayleigh_damping_factor, &
              rayleigh_damping_height, recycling_width, residual_limit, &
@@ -223,5 +233,6 @@
              statistic_regions, subs_vertical_gradient, &
              subs_vertical_gradient_level, surface_heatflux, surface_pressure, &
-             surface_scalarflux, surface_waterflux, s_surface, &
+             surface_scalarflux, surface_waterflux, surface_waterflux_nr, &
+             surface_waterflux_qr, s_surface, &
              s_surface_initial_change, s_vertical_gradient, &
              s_vertical_gradient_level, timestep_scheme, &
@@ -232,8 +243,8 @@
              use_top_fluxes, use_ug_for_galilei_tr, use_upstream_for_tke, &
              uv_heights, u_bulk, u_profile, vg_surface, vg_vertical_gradient, &
-             vg_vertical_gradient_level, v_bulk, v_profile, wall_adjustment, &
-             wall_heatflux, wall_humidityflux, wall_scalarflux, z0h_factor
-
-
+             vg_vertical_gradient_level, v_bulk, v_profile, ventilation_effect, &
+             wall_adjustment, wall_heatflux, wall_humidityflux, wall_scalarflux, &
+             z0h_factor
+      
     NAMELIST /d3par/  averaging_interval, averaging_interval_pr, &
              create_disturbances, &
@@ -391,4 +402,5 @@
 !--                  also check the allocate statement in routine read_var_list
              ALLOCATE( lad(0:nz+1),pt_init(0:nz+1), q_init(0:nz+1),           &
+                       qr_init(0:nz+1), nr_init(0:nz+1),                      &
                        sa_init(0:nz+1), ug(0:nz+1), u_init(0:nz+1),           &
                        v_init(0:nz+1), vg(0:nz+1),                            &
